// David Pilling June 2017


#include <stdarg.h>

void pr(char *fmt, ... )
{

  
  char buf[128]; // resulting string limited to 128 chars
  va_list args;
  va_start (args, fmt );
  vsnprintf(buf, 128, fmt, args);
  va_end (args);
  Serial.println(buf);


//delay(5);
}




#include "HX711.h"

HX711 scale;


// the input pin used to monitor the step signal to the Z axis motor driver
#define STEP_PIN 2

// the input pin used to monuitor the direction signal to the Z axis motor driver
#define DIR_PIN 5

// the output pin used to emulate a limit/endstop switch
#define SWITCH_PIN 6

// the time in ms after which we assume the Z axis motor is at rest
#define STRAINTIMEOUT 500

// the threshold for strain gauge output to indicate bed contact
// how small this can be depends on the noise level of the HX711
// for one type I used a value of 8000
#define THRESHOLD 12000

// the number of steps that the exponential average is computed over
#define STRAINAVERAGE 250


#define UPWARDS 1
#define DOWNWARDS 0

int dir; // 1 == up
int olddir;

int endstop;


long strain;
long oldstrain;
long deltastrain;
volatile unsigned int step_count;
unsigned int last_step_count;

unsigned long lastmovetime;

long runningstrain;
unsigned int runningsteps;
int rawdata=0;



void step_interrupt(void) 
{
 step_count++;
}



#include <SerialCommand.h>

SerialCommand sCmd;


void cmdraw(const char *command)
{
 rawdata=1;
}  

void cmdcooked(const char *command)
{
 rawdata=0;
}  


void cmdunrecognized(const char *command)
{
 Serial.println("What?"); 
}

void setup_serial(void)
{
 Serial.begin(38400);

 sCmd.addCommand("raw",cmdraw);
 sCmd.addCommand("cooked",cmdcooked);
 
 sCmd.setDefaultHandler(cmdunrecognized);  
}



void setup() 
{
 setup_serial();
 // parameter "gain" is ommited; the default value 128 is used by the library
 // HX711.DOUT	- pin #A1
 // HX711.PD_SCK	- pin #A0
 scale.begin(A1, A0);

 scale.set_scale(1.f);
// scale.tare(10);

 pinMode(STEP_PIN,INPUT);
 pinMode(DIR_PIN, INPUT);
 pinMode(SWITCH_PIN, OUTPUT); 

 attachInterrupt(0, step_interrupt, RISING);

 digitalWrite(SWITCH_PIN, LOW);
}

void loop() 
{
 strain=((long)scale.read_average(1));

 if(step_count!=last_step_count)
 {
  int deltasteps=step_count-last_step_count;
  last_step_count=step_count;
  dir=digitalRead(DIR_PIN);
  if(dir!=olddir)
  {
   deltastrain=0;
   olddir=dir;
   runningstrain=0;
   runningsteps=0; 
  }

  deltastrain+=strain-oldstrain;
  lastmovetime=millis();

  if(deltasteps>STRAINAVERAGE) deltasteps=STRAINAVERAGE;
  runningsteps+=deltasteps;
  if(runningsteps>STRAINAVERAGE) runningsteps=STRAINAVERAGE;
  runningstrain=(((long long)(runningsteps-deltasteps)*(long long)runningstrain+(long long)deltasteps*(long long)deltastrain)/(long long)runningsteps);
  
  if(dir==DOWNWARDS)
  {
   if((deltastrain-runningstrain)<-THRESHOLD)
   {
    endstop=THRESHOLD;
    digitalWrite(SWITCH_PIN, HIGH);
   }
  }
  else
  {
   if((deltastrain-runningstrain)<THRESHOLD)
   {
    endstop=0;
    digitalWrite(SWITCH_PIN, LOW);
   }
  }
  if(rawdata==0) pr("%ld,%d",deltastrain-runningstrain,endstop);
 }
 else
 {
  if((millis()-lastmovetime)>STRAINTIMEOUT)
  {
   deltastrain=0;    
   runningstrain=0;
   runningsteps=0; 
  }

  if(Serial.available()>0) 
  {
   sCmd.readSerial();
  }
 }
 if(rawdata==1) pr("%ld",strain);
 oldstrain=strain;
}




